#version 330                                                                        
                                                                                    
layout (location = 0) in vec3 Position;                                             
layout (location = 1) in vec2 TexCoord;  
layout (location = 2) in vec3 Normal;
layout (location = 3) in vec3 Tangent;                                            

uniform mat4 gWVP;
uniform mat4 gV;
uniform mat4 gWorld;
                                        
out vec2 TexCoord0;                                                                 
out vec3 Normal0;                                                                   
out vec3 WorldPos0;  
out mat3 tbnMatrix;                                                               


void main()
{       
    gl_Position    = gWVP * vec4(Position, 1.0);
    TexCoord0      = TexCoord;                    
    WorldPos0      = (gWorld * vec4(Position, 1.0)).xyz;
	Normal0        = (gWorld * vec4(Normal, 0.0)).xyz; 
    
	
	// Normal of the the vertex, in camera space
	//vec3 Normal_cameraspace = normalize(( gV * gWorld * vec4(Normal,0)).xyz); // Only correct if ModelMatrix does not scale the model ! Use its inverse transpose if not.
	//vec3 Tangent_cameraspace = normalize(( gV * gWorld * vec4(Tangent,0)).xyz);

	//Tangent_cameraspace = normalize(Tangent_cameraspace -  dot(Tangent_cameraspace, Normal_cameraspace) * Normal_cameraspace);

	//vec3 biTangent = cross(Tangent_cameraspace, Normal_cameraspace);

	//tbnMatrix = mat3(Tangent_cameraspace, biTangent, Normal_cameraspace);

}